import { __awaiter, __generator, __spread } from 'tslib';
import { createInstance, LOCALSTORAGE } from 'localforage';
import { SubscriptionClient } from 'subscriptions-transport-ws';
import { ApolloClient } from 'apollo-client';
import { createHttpLink } from 'apollo-link-http';
import { WebSocketLink } from 'apollo-link-ws';
import { InMemoryCache } from 'apollo-cache-inmemory';
import { split } from 'apollo-link';
import { getMainDefinition } from 'apollo-utilities';
import { delay } from 'bluebird';
import { Injectable, Component, NgModule, APP_INITIALIZER, Optional, SkipSelf } from '@angular/core';
import { Router, RouterModule } from '@angular/router';
import { ToastController, LoadingController, IonicModule } from '@ionic/angular';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/ec.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function ECLite() { }
if (false) {
    /** @type {?} */
    ECLite.prototype.fetch;
    /** @type {?} */
    ECLite.prototype.WebSocket;
}
var EdgeCentralConfig = /** @class */ (function () {
    function EdgeCentralConfig() {
    }
    return EdgeCentralConfig;
}());
if (false) {
    /** @type {?} */
    EdgeCentralConfig.prototype.cloudCentralHost;
    /** @type {?} */
    EdgeCentralConfig.prototype.edgeCN;
    /** @type {?} */
    EdgeCentralConfig.prototype.ecvcHost;
    /** @type {?} */
    EdgeCentralConfig.prototype.inSecure;
}
/**
 * @record
 */
function EdgeCentralClientConfig() { }
if (false) {
    /** @type {?} */
    EdgeCentralClientConfig.prototype.apiUrl;
    /** @type {?} */
    EdgeCentralClientConfig.prototype.subscriptionUrl;
    /** @type {?} */
    EdgeCentralClientConfig.prototype.token;
}
var EdgeCentralClient = /** @class */ (function () {
    /* eslint-disable no-useless-constructor */
    function EdgeCentralClient(config) {
        this.config = config;
        this.httpProtocol = 'https';
        this.wsProtocol = 'wss';
        this.store = createInstance({
            name: 'ec-client',
            driver: LOCALSTORAGE
        });
        if (config.inSecure) {
            // set protocol to insecure protocol
            this.httpProtocol = 'http';
            this.wsProtocol = 'ws';
        }
    }
    /**
     * @return {?}
     */
    EdgeCentralClient.prototype.isAuthenticated = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var config;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // TODO: use more shopisticated detection mechanism
                    return [4 /*yield*/, delay(500)];
                    case 1:
                        // TODO: use more shopisticated detection mechanism
                        _a.sent();
                        /* eslint-disable no-console */
                        console.log('using chrome extensions?', this.isUsingChromeExtension());
                        if (this.isUsingChromeExtension()) {
                            return [2 /*return*/, true];
                        }
                        return [4 /*yield*/, this.getClientConfig()];
                    case 2:
                        config = _a.sent();
                        if (!config.token) {
                            return [2 /*return*/, false];
                        }
                        return [2 /*return*/, true];
                }
            });
        });
    };
    /**
     * return true when chrome inject script from ec-lite extenstion are presents
     */
    /**
     * return true when chrome inject script from ec-lite extenstion are presents
     * @return {?}
     */
    EdgeCentralClient.prototype.isUsingChromeExtension = /**
     * return true when chrome inject script from ec-lite extenstion are presents
     * @return {?}
     */
    function () {
        if (window.eclite) {
            return true;
        }
        return false;
    };
    /**
     * @return {?}
     */
    EdgeCentralClient.prototype.loadApolloClient = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this;
                        return [4 /*yield*/, this.createApolloClient()];
                    case 1:
                        _a.client = _b.sent();
                        console.log('client loaded!', this.client);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    EdgeCentralClient.prototype.createApolloClient = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var config, httpLink, wsClient, wsLink, cache, link, client;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // TODO: use more shopisticated detection mechanism
                    return [4 /*yield*/, delay(500)];
                    case 1:
                        // TODO: use more shopisticated detection mechanism
                        _a.sent();
                        // get client configurations
                        return [4 /*yield*/, this.getClientConfig()];
                    case 2:
                        config = _a.sent();
                        // HTTP connection to the API
                        httpLink = createHttpLink({
                            uri: config.apiUrl,
                            fetch: (/**
                             * @param {?} input
                             * @param {?} init
                             * @return {?}
                             */
                            function (input, init) { return __awaiter(_this, void 0, void 0, function () {
                                var conf, url;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, this.getClientConfig()];
                                        case 1:
                                            conf = _a.sent();
                                            url = conf.apiUrl || input;
                                            // set authorization header
                                            if (init.headers && init.headers.set) {
                                                init.headers.set('Authorization', "Bearer " + conf.token);
                                            }
                                            else {
                                                init.headers = init.headers || ((/** @type {?} */ ({})));
                                                init.headers.Authorization = "Bearer " + conf.token;
                                            }
                                            // using eclite offline first fetch
                                            // when chrome extension are present
                                            if (this.isUsingChromeExtension()) {
                                                return [2 /*return*/, window.eclite.fetch(url, init)];
                                            }
                                            return [2 /*return*/, fetch(url, init)];
                                    }
                                });
                            }); })
                        });
                        // subscriptions link
                        wsClient = new SubscriptionClient(config.subscriptionUrl, {
                            reconnect: true
                        }, 
                        // using eclite offline first websocket
                        // when chrome extension are present
                        this.isUsingChromeExtension() ? window.eclite.WebSocket : WebSocket);
                        wsClient.use([
                            {
                                applyMiddleware: (/**
                                 * @param {?} operationOptions
                                 * @param {?} next
                                 * @return {?}
                                 */
                                function (operationOptions, next) { return __awaiter(_this, void 0, void 0, function () {
                                    var conf;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0: return [4 /*yield*/, this.getClientConfig()];
                                            case 1:
                                                conf = _a.sent();
                                                operationOptions.token = conf.token;
                                                next();
                                                return [2 /*return*/];
                                        }
                                    });
                                }); })
                            }
                        ]);
                        wsLink = new WebSocketLink(wsClient);
                        // Cache implementation
                        cache = new InMemoryCache();
                        // using the ability to split links, you can send data to each link
                        // depending on what kind of operation is being sent
                        link = split((
                        // split based on operation type
                        // split based on operation type
                        /**
                         * @param {?} __0
                         * @return {?}
                         */
                        function (_a) {
                            var query = _a.query;
                            /** @type {?} */
                            var definition = getMainDefinition(query);
                            return (definition.kind === 'OperationDefinition' &&
                                definition.operation === 'subscription');
                        }), wsLink, httpLink);
                        // Create apollo client
                        client = new ApolloClient({
                            link: link,
                            cache: cache
                        });
                        return [2 /*return*/, client];
                }
            });
        });
    };
    /**
     * @param {?} config
     * @return {?}
     */
    EdgeCentralClient.prototype.setClientConfig = /**
     * @param {?} config
     * @return {?}
     */
    function (config) {
        return this.store.setItem('config', config);
    };
    /**
     * @return {?}
     */
    EdgeCentralClient.prototype.getClientConfig = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var config;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.store.getItem('config')];
                    case 1:
                        config = _a.sent();
                        // using default config when config not present
                        if (!config) {
                            return [2 /*return*/, {
                                    apiUrl: "https://" + this.config.ecvcHost + "/graphql",
                                    subscriptionUrl: "wss://" + this.config.ecvcHost + "/subscriptions",
                                    token: null
                                }];
                        }
                        return [2 /*return*/, config];
                }
            });
        });
    };
    /**
     * logout and clear client contexts
     */
    /**
     * logout and clear client contexts
     * @return {?}
     */
    EdgeCentralClient.prototype.logout = /**
     * logout and clear client contexts
     * @return {?}
     */
    function () {
        return this.store.removeItem('config');
    };
    /**
     * @param {?} providerId
     * @param {?} password
     * @return {?}
     */
    EdgeCentralClient.prototype.loginByProvider = /**
     * @param {?} providerId
     * @param {?} password
     * @return {?}
     */
    function (providerId, password) {
        return __awaiter(this, void 0, void 0, function () {
            var res, errMessage, token;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fetch(this.httpProtocol + "://" + this.config.cloudCentralHost + "/login-provider", {
                            method: 'POST',
                            mode: 'cors',
                            headers: {
                                'Content-Type': 'application/json'
                            },
                            body: JSON.stringify({
                                provider_id: providerId,
                                password: password
                            })
                        })];
                    case 1:
                        res = _a.sent();
                        if (!res.ok) {
                            errMessage = 'Gagal melakukan login';
                            switch (res.status) {
                                case 404:
                                case 403:
                                case 401:
                                    errMessage = 'Kode Faskes & Password tidak cocok';
                                    break;
                                case 500:
                                    errMessage = 'Maaf, Server kami mengalami gangguan';
                                    break;
                            }
                            throw new Error(errMessage);
                        }
                        // get token
                        return [4 /*yield*/, res.json()];
                    case 2:
                        token = (_a.sent()).token;
                        // apply configurations
                        return [4 /*yield*/, this.setClientConfig({
                                apiUrl: this.httpProtocol + "://" + this.config.ecvcHost + "/graphql",
                                subscriptionUrl: this.wsProtocol + "://" + this.config.ecvcHost + "/subscriptions",
                                token: token
                            })];
                    case 3:
                        // apply configurations
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @param {?} deviceId
     * @return {?}
     */
    EdgeCentralClient.prototype.loginByDevice = /**
     * @param {?} deviceId
     * @return {?}
     */
    function (deviceId) {
        return __awaiter(this, void 0, void 0, function () {
            var apiUrl, subscriptionUrl, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        apiUrl = this.httpProtocol + "://" + deviceId + "." + this.config.edgeCN + "/graphql";
                        subscriptionUrl = this.wsProtocol + "://" + deviceId + "." + this.config.edgeCN + "/subscriptions";
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, fetch(apiUrl, {
                                method: 'POST',
                                mode: 'cors',
                                headers: {
                                    'Content-Type': 'application/json'
                                },
                                body: JSON.stringify({
                                    query: "{\n            __schema {\n              types {\n                name\n              }\n            }\n          }",
                                    operationName: null,
                                    variables: {}
                                })
                            })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        throw new Error('Gagal mendapatkan koneksi, pastikan device anda dalam satu jaringan');
                    case 4: 
                    // apply configurations
                    return [4 /*yield*/, this.setClientConfig({
                            apiUrl: apiUrl,
                            subscriptionUrl: subscriptionUrl,
                            token: '--ec-on-device-token--'
                        })];
                    case 5:
                        // apply configurations
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return EdgeCentralClient;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    EdgeCentralClient.prototype.store;
    /** @type {?} */
    EdgeCentralClient.prototype.client;
    /**
     * @type {?}
     * @private
     */
    EdgeCentralClient.prototype.httpProtocol;
    /**
     * @type {?}
     * @private
     */
    EdgeCentralClient.prototype.wsProtocol;
    /**
     * @type {?}
     * @private
     */
    EdgeCentralClient.prototype.config;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/ec.service-provider.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * wrapped edge central client so it injectable
 * @param {?} config
 * @return {?}
 */
function provideEdgeCentralService(config) {
    return new EdgeCentralClient(config);
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/auth-guard.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var EdgeCentralGuardService = /** @class */ (function () {
    function EdgeCentralGuardService(ec, router) {
        this.ec = ec;
        this.router = router;
    }
    /**
     * Return true when user are authenticated
     */
    /**
     * Return true when user are authenticated
     * @return {?}
     */
    EdgeCentralGuardService.prototype.canActivate = /**
     * Return true when user are authenticated
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.ec.isAuthenticated()];
                    case 1:
                        if (_a.sent()) {
                            return [2 /*return*/, true];
                        }
                        this.router.navigate(['/login']);
                        return [2 /*return*/, false];
                }
            });
        });
    };
    EdgeCentralGuardService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    EdgeCentralGuardService.ctorParameters = function () { return [
        { type: EdgeCentralClient },
        { type: Router }
    ]; };
    return EdgeCentralGuardService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    EdgeCentralGuardService.prototype.ec;
    /**
     * @type {?}
     * @private
     */
    EdgeCentralGuardService.prototype.router;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/login.page.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LoginPage = /** @class */ (function () {
    function LoginPage(toast, loading, router, ec) {
        this.toast = toast;
        this.loading = loading;
        this.router = router;
        this.ec = ec;
        this.tab = 'device';
    }
    /**
     * @param {?} event
     * @return {?}
     */
    LoginPage.prototype.tabChanged = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.tab = event.detail.value;
    };
    /**
     * @return {?}
     */
    LoginPage.prototype.loginDevice = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var loading, err_1, toast;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.loading.create({
                            message: 'Menghubungkan...'
                        })];
                    case 1:
                        loading = _a.sent();
                        return [4 /*yield*/, loading.present()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _a.trys.push([3, 7, , 10]);
                        return [4 /*yield*/, this.ec.loginByDevice(this.deviceID)];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, delay(1000)];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, loading.dismiss()];
                    case 6:
                        _a.sent();
                        // redirect to root page
                        this.router.navigate(['/']);
                        return [3 /*break*/, 10];
                    case 7:
                        err_1 = _a.sent();
                        return [4 /*yield*/, this.toast.create({
                                message: err_1.message || err_1.toString(),
                                color: 'danger',
                                duration: 5000
                            })];
                    case 8:
                        toast = _a.sent();
                        return [4 /*yield*/, toast.present()];
                    case 9:
                        _a.sent();
                        return [3 /*break*/, 10];
                    case 10: return [4 /*yield*/, loading.dismiss()];
                    case 11:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    LoginPage.prototype.loginProvider = /**
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var loading, err_2, toast;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.loading.create({
                            message: 'Menghubungkan...'
                        })];
                    case 1:
                        loading = _a.sent();
                        return [4 /*yield*/, loading.present()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _a.trys.push([3, 7, , 10]);
                        return [4 /*yield*/, this.ec.loginByProvider(this.providerID, this.password)];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, delay(1000)];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, loading.dismiss()];
                    case 6:
                        _a.sent();
                        // redirect to root page
                        this.router.navigate(['/']);
                        return [3 /*break*/, 10];
                    case 7:
                        err_2 = _a.sent();
                        return [4 /*yield*/, this.toast.create({
                                message: err_2.message || err_2.toString(),
                                color: 'danger',
                                duration: 5000
                            })];
                    case 8:
                        toast = _a.sent();
                        return [4 /*yield*/, toast.present()];
                    case 9:
                        _a.sent();
                        return [3 /*break*/, 10];
                    case 10: return [4 /*yield*/, loading.dismiss()];
                    case 11:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LoginPage.decorators = [
        { type: Component, args: [{
                    selector: 'sr-login-page',
                    template: "<ion-header translucent>\r\n  <ion-toolbar>\r\n    <ion-title>Login</ion-title>\r\n  </ion-toolbar>\r\n</ion-header>\r\n\r\n<ion-content>\r\n  <ion-grid>\r\n    <ion-row class=\"ion-align-items-center ion-justify-content-center\">\r\n      <ion-col size-md=\"8\" size-sm>\r\n        <ion-card>\r\n          <ion-card-header>\r\n            <ion-segment (ionChange)=\"tabChanged($event)\" [value]=\"tab\">\r\n              <ion-segment-button value=\"device\" id=\"login-device\">\r\n                <ion-label>Login dengan kode perangkat</ion-label>\r\n              </ion-segment-button>\r\n              <ion-segment-button value=\"provider\" id=\"login-provider\">\r\n                <ion-label>Login dengan kode faskes</ion-label>\r\n              </ion-segment-button>\r\n            </ion-segment>\r\n          </ion-card-header>\r\n\r\n          <ion-card-content>\r\n            <ng-container *ngIf=\"tab === 'device'\">\r\n              <form ngForm #loginDeviceForm=\"ngForm\">\r\n                <ion-list lines=\"full\" class=\"ion-no-margin ion-no-padding\">\r\n                  <ion-item>\r\n                    <ion-label position=\"floating\">\r\n                      kode perangkat\r\n                      <ion-text\r\n                        color=\"danger\"\r\n                        *ngIf=\"device_id.invalid && (device_id.dirty || device_id.touched)\"\r\n                      >\r\n                        <span *ngIf=\"device_id?.errors?.required\">\r\n                          wajib diisi\r\n                        </span>\r\n                      </ion-text>\r\n                    </ion-label>\r\n                    <ion-input\r\n                      name=\"device_id\"\r\n                      [(ngModel)]=\"deviceID\"\r\n                      type=\"text\"\r\n                      placeholder=\"misal prkt123\"\r\n                      required\r\n                      #device_id=\"ngModel\"\r\n                      id=\"device-id\"\r\n                    ></ion-input>\r\n                  </ion-item>\r\n                </ion-list>\r\n                <div class=\"ion-padding\">\r\n                  <ion-button\r\n                    shape=\"round\"\r\n                    expand=\"block\"\r\n                    color=\"primary\"\r\n                    (click)=\"loginDevice()\"\r\n                    [disabled]=\"!loginDeviceForm.form.valid\"\r\n                    id=\"submit-device\"\r\n                  >\r\n                    <ion-icon slot=\"start\" name=\"unlock\"></ion-icon>\r\n                    Login\r\n                  </ion-button>\r\n                </div>\r\n              </form>\r\n            </ng-container>\r\n\r\n            <ng-container *ngIf=\"tab === 'provider'\">\r\n              <form ngForm #loginProviderForm=\"ngForm\">\r\n                <ion-list lines=\"full\" class=\"ion-no-margin ion-no-padding\">\r\n                  <ion-item>\r\n                    <ion-label position=\"floating\">\r\n                      kode faskes\r\n                      <ion-text\r\n                        color=\"danger\"\r\n                        *ngIf=\"provider_id.invalid && (provider_id.dirty || provider_id.touched)\"\r\n                      >\r\n                        <span *ngIf=\"provider_id?.errors?.required\">\r\n                          wajib diisi\r\n                        </span>\r\n                      </ion-text>\r\n                    </ion-label>\r\n                    <ion-input\r\n                      name=\"provider_id\"\r\n                      [(ngModel)]=\"providerID\"\r\n                      type=\"text\"\r\n                      placeholder=\"misal klinik_sehat\"\r\n                      required\r\n                      #provider_id=\"ngModel\"\r\n                      id=\"provider-code\"\r\n                    ></ion-input>\r\n                  </ion-item>\r\n\r\n                  <ion-item>\r\n                    <ion-label position=\"floating\">\r\n                      password\r\n                      <ion-text\r\n                        color=\"danger\"\r\n                        *ngIf=\"passwords.invalid && (passwords.dirty || passwords.touched)\"\r\n                      >\r\n                        <span *ngIf=\"passwords?.errors?.required\">\r\n                          wajib diisi\r\n                        </span>\r\n                      </ion-text>\r\n                    </ion-label>\r\n                    <ion-input\r\n                      name=\"password\"\r\n                      [(ngModel)]=\"password\"\r\n                      type=\"password\"\r\n                      required\r\n                      #passwords=\"ngModel\"\r\n                      id=\"provider-password\"\r\n                    ></ion-input>\r\n                  </ion-item>\r\n                </ion-list>\r\n\r\n                <div class=\"ion-padding\">\r\n                  <ion-button\r\n                    shape=\"round\"\r\n                    expand=\"block\"\r\n                    color=\"primary\"\r\n                    (click)=\"loginProvider()\"\r\n                    [disabled]=\"!loginProviderForm.form.valid\"\r\n                    id=\"submit-provider\"\r\n                  >\r\n                    <ion-icon slot=\"start\" name=\"unlock\"></ion-icon>\r\n                    Login\r\n                  </ion-button>\r\n                </div>\r\n              </form>\r\n            </ng-container>\r\n          </ion-card-content>\r\n        </ion-card>\r\n      </ion-col>\r\n    </ion-row>\r\n  </ion-grid>\r\n</ion-content>\r\n"
                }] }
    ];
    /** @nocollapse */
    LoginPage.ctorParameters = function () { return [
        { type: ToastController },
        { type: LoadingController },
        { type: Router },
        { type: EdgeCentralClient }
    ]; };
    return LoginPage;
}());
if (false) {
    /** @type {?} */
    LoginPage.prototype.tab;
    /** @type {?} */
    LoginPage.prototype.deviceID;
    /** @type {?} */
    LoginPage.prototype.providerID;
    /** @type {?} */
    LoginPage.prototype.password;
    /**
     * @type {?}
     * @private
     */
    LoginPage.prototype.toast;
    /**
     * @type {?}
     * @private
     */
    LoginPage.prototype.loading;
    /**
     * @type {?}
     * @private
     */
    LoginPage.prototype.router;
    /**
     * @type {?}
     * @private
     */
    LoginPage.prototype.ec;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ec.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} ec
 * @return {?}
 */
function initEdgeCentralClient(ec) {
    /** @type {?} */
    var loader = (/**
     * @return {?}
     */
    function () { return ec.loadApolloClient(); });
    return loader;
}
var ɵ0 = provideEdgeCentralService;
/**
 *
 * @export
 */
var EdgeCentralModule = /** @class */ (function () {
    /**
     * Creates an instance of EdgeCentralModule.
     * throw error if EdgeCentralModule already created on parent
     */
    function EdgeCentralModule(parentModule) {
        if (parentModule) {
            throw new Error('EdgeCentralModule is already loaded. Import it in the AppModule only');
        }
    }
    /**
     * Create new module instance with edge central config service
     *
     */
    /**
     * Create new module instance with edge central config service
     *
     * @param {?} config
     * @return {?}
     */
    EdgeCentralModule.forRoot = /**
     * Create new module instance with edge central config service
     *
     * @param {?} config
     * @return {?}
     */
    function (config) {
        return {
            ngModule: EdgeCentralModule,
            providers: [{ provide: EdgeCentralConfig, useValue: config }]
        };
    };
    EdgeCentralModule.decorators = [
        { type: NgModule, args: [{
                    imports: [IonicModule.forRoot({ mode: 'ios' })],
                    providers: [
                        {
                            provide: EdgeCentralClient,
                            useFactory: ɵ0,
                            deps: [EdgeCentralConfig]
                        },
                        {
                            provide: APP_INITIALIZER,
                            useFactory: initEdgeCentralClient,
                            deps: [EdgeCentralClient],
                            multi: true
                        },
                        EdgeCentralGuardService
                    ]
                },] }
    ];
    /** @nocollapse */
    EdgeCentralModule.ctorParameters = function () { return [
        { type: EdgeCentralModule, decorators: [{ type: Optional }, { type: SkipSelf }] }
    ]; };
    return EdgeCentralModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ec-login.router.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var routes = [{ path: '', component: LoginPage }];
/**
 * Login Router modules
 * @export
 */
var EdgeCentralLoginRoutingModule = /** @class */ (function () {
    function EdgeCentralLoginRoutingModule() {
    }
    EdgeCentralLoginRoutingModule.decorators = [
        { type: NgModule, args: [{
                    imports: [RouterModule.forChild(routes)],
                    exports: [],
                    declarations: []
                },] }
    ];
    return EdgeCentralLoginRoutingModule;
}());
/** @type {?} */
var routedComponents = [LoginPage];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ec-login.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Module to provide context user interface before accessing edge central features
 *
 * @export
 */
var EdgeCentralLoginModule = /** @class */ (function () {
    function EdgeCentralLoginModule() {
    }
    EdgeCentralLoginModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        IonicModule,
                        CommonModule,
                        EdgeCentralLoginRoutingModule,
                        FormsModule,
                        ReactiveFormsModule
                    ],
                    declarations: __spread(routedComponents)
                },] }
    ];
    return EdgeCentralLoginModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: sirusdev-ec-client-angular.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { EdgeCentralClient, EdgeCentralConfig, EdgeCentralGuardService, EdgeCentralLoginModule, EdgeCentralModule, LoginPage, initEdgeCentralClient, provideEdgeCentralService, EdgeCentralLoginRoutingModule as ɵa, routedComponents as ɵb };
//# sourceMappingURL=sirusdev-ec-client-angular.js.map
